export default class ProximSensors {

    // variables of Machine: ProximSensors
    #sensorsData;

    // scalar formal parameters
    #maxMsrblDst;

    constructor(maxMsrblDst) {
        this.#maxMsrblDst = maxMsrblDst;
        this.#sensorsData = ArrayUtils.initialiseArray(7-0+1, 0);
        //console.log("ProximSensors.#sensorsData: "+this.#sensorsData);
    }

    readSensors(nne, ene, ese, sse, ssw, wsw, wnw, nnw) {
        if ((((((((((((((((0 <= nne && nne <= this.#maxMsrblDst) && 0 <= ene) && ene <= this.#maxMsrblDst) && 0 <= ese) && ese <= this.#maxMsrblDst) && 0 <= sse) && sse <= this.#maxMsrblDst) && 0 <= ssw) && ssw <= this.#maxMsrblDst) && 0 <= wsw) && wsw <= this.#maxMsrblDst) && 0 <= wnw) && wnw <= this.#maxMsrblDst) && 0 <= nnw) && nnw <= this.#maxMsrblDst)) {
            this.#sensorsData[0-(0)] = nne;
            this.#sensorsData[1-(0)] = ene;
            this.#sensorsData[2-(0)] = ese;
            this.#sensorsData[3-(0)] = sse;
            this.#sensorsData[4-(0)] = ssw;
            this.#sensorsData[5-(0)] = wsw;
            this.#sensorsData[6-(0)] = wnw;
            this.#sensorsData[7-(0)] = nnw;
        }
        //console.log("readSensors> ProximSensors.#sensorsData: "+this.#sensorsData);
    }

    allClear(dst) {
        //Boolean
        let bb;
        if ((((((((this.#sensorsData[0-(0)] > dst && this.#sensorsData[1-(0)] > dst) && this.#sensorsData[2-(0)] > dst) && this.#sensorsData[3-(0)] > dst) && this.#sensorsData[4-(0)] > dst) && this.#sensorsData[5-(0)] > dst) && this.#sensorsData[6-(0)] > dst) && this.#sensorsData[7-(0)] > dst)) {
            bb = true;
        }
        else {
            bb = false;
        }
        return bb;
    }

    frontClear(angle, dst_data) {
        //Boolean
        let bb;
        if (((0 <= angle && angle <= 21599) && dst_data >= 0)) {
            // manual changes in the following code to assure integer division: x/y >> Math.trunc(x/y)
            if (((this.#sensorsData[(Math.trunc(angle/2700)+7)%8-(0)] > dst_data && this.#sensorsData[Math.trunc(angle/2700)-(0)] > dst_data) && this.#sensorsData[(Math.trunc(angle/2700)+1)%8-(0)] > dst_data)) {
                bb = true;
            }
            else {
                bb = false;
            }
        }
        else {
            bb = false;
        }
        return bb;
    }

}
import ArrayUtils from "./ArrayUtils.js";
