/* global NAF */ 
/**
 * This script adds schemas, used by the networked-aframe
 */


// see issue https://github.com/networked-aframe/networked-aframe/issues/267
NAF.schemas.getComponentsOriginal = NAF.schemas.getComponents;      
NAF.schemas.getComponents = (template) => {

if (!NAF.schemas.hasTemplate("#template-avatar-citizen")) {
  NAF.schemas.add({
    template: "#template-avatar-citizen",
    components: [
      "position",
      "rotation",
      {
        selector: ".head",
        component: "material",
        property: "color",
      },
    ],
  });
}
if (!NAF.schemas.hasTemplate("#template-avatar-cbot")) {
  NAF.schemas.add({
    template: "#template-avatar-cbot",
    components: [
      "position",
      "rotation",
      {
        selector: ".cbot-head",
        component: "material",
        property: "color",
      },
    ],
  });
}
if (!NAF.schemas.hasTemplate("#dirty-location")) {
  NAF.schemas.add({
      template: "#dirty-location",
      components: [
          "position",
          "rotation",
          "material"
      ]
  });
}
if (!NAF.schemas.hasTemplate("#parking-location")) {
  NAF.schemas.add({
      template: "#parking-location",
      components: [
          "position",
          "rotation",
          "material"
      ]
  });
}

const components = NAF.schemas.getComponentsOriginal(template);
return components;
};
