/* global AFRAME*/

/**
 * Component for handling dirty positions in the scene
 */
AFRAME.registerComponent("cbot-dirty-position", {
    schema: {
        dirtiness: {type: "int", default: 250},
        MAX_DIRTINESS : {type: "int", default: 250}
    },

    init: function () {
        
        this.el.setAttribute("material", "color", "brown");
        this.el.setAttribute("material", "transparent", true);        
    },

    update: function () {
        this.el.setAttribute("material", "opacity", this.data.dirtiness / this.data.MAX_DIRTINESS);
    },
  
    doCleaningStep: function (dirtinessDecrease) {
      let newDirtiness=this.data.dirtiness-dirtinessDecrease;
      if(newDirtiness<0) {newDirtiness=0;} 
      this.el.setAttribute("cbot-dirty-position", "dirtiness", newDirtiness);
    },
  
    isClean: function () {
      if(this.data.dirtiness>0) {return false;} else  {return true;}
    },
  
    makeDirty: function () {
      this.el.setAttribute("cbot-dirty-position", "dirtiness", this.data.MAX_DIRTINESS);
    },
  
  
  
  
//     //You may uncomment this code to see how the dirty positions disappear
//     tick: function () {
//       //the next line cannot be replaced by this.data.dirtiness--; this.el.setAttribute must be called to trigger the update function execution
//       this.el.setAttribute("cbot-dirty-position", "dirtiness", this.data.dirtiness-0.5);
  
//     }
    
  
  

});
